; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_BEGRUESSUNG:
    rcall LCD_CLEAR

    ldi temp, 'B'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'E'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'R'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'N'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'H'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'A'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'R'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'D'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, '.'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'E'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'R'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'F'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'U'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'R'        ;
    rcall LCD_DATA
    rcall wait_100ms
    ldi temp, 'T'        ;
    rcall LCD_DATA

    rcall wait_1s
    rcall wait_1s
; ----------------------------------------------
    rcall LCD_CLEAR

    ; ZEILE1
    ldi ZH, high(TEXT_BEGRUESSUNG_1*2)    ; TEXT
    ldi ZL,  low(TEXT_BEGRUESSUNG_1*2)
    rcall ANZEIGE_TEXT

    ; ZEILE2
    rcall LCD_ZEILE2

    ldi ZH, high(TEXT_BEGRUESSUNG_2*2)    ; TEXT
    ldi ZL,  low(TEXT_BEGRUESSUNG_2*2)
    rcall ANZEIGE_TEXT
    rcall wait_1s
    rcall wait_1s
; ----------------------------------------------
    rcall LCD_CLEAR

    ; ZEILE1
    ldi ZH, high(TEXT_BEGRUESSUNG_3*2)    ; TEXT
    ldi ZL,  low(TEXT_BEGRUESSUNG_3*2)
    rcall ANZEIGE_TEXT

    ; ZEILE2
    rcall LCD_ZEILE2

    ldi ZH, high(TEXT_BEGRUESSUNG_4*2)    ; TEXT
    ldi ZL,  low(TEXT_BEGRUESSUNG_4*2)
    rcall ANZEIGE_TEXT
    rcall wait_1s
    rcall wait_1s
; ----------------------------------------------
    rcall LCD_CLEAR


    ; ZEILE1
    ldi ZH, high(TEXT_BEGRUESSUNG_5*2)    ; TEXT
    ldi ZL,  low(TEXT_BEGRUESSUNG_5*2)
    rcall ANZEIGE_TEXT

    ; ZEILE2
    rcall LCD_ZEILE2

    ldi ZH, high(TEXT_BEGRUESSUNG_6*2)    ; TEXT
    ldi ZL,  low(TEXT_BEGRUESSUNG_6*2)
    rcall ANZEIGE_TEXT
    rcall wait_1s
    rcall wait_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_EDIT_VIEW:
    ; TASTE
    LDS temp,(adr_TASTE)
    ; TASTE + gedrckt ?
    cpi temp,(TASTE_PLUS)
    breq ANZEIGE_EDIT_VIEW_PLUS

    ; ANZEIGE
    rcall LCD_CLEAR
    ; ZEILE1
    ldi ZH, high(TEXT_EDIT_VIEW*2)    ; TEXT
    ldi ZL,  low(TEXT_EDIT_VIEW*2)
    rcall ANZEIGE_TEXT
    ret

ANZEIGE_EDIT_VIEW_PLUS:
    ; MENUE-EBENE = 1
    STS (adr_MENUE_EBENE),EINS
    ; MENUE = NULL
    STS (adr_MENUE),NULL

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_LEER_MENUE:
    ; CLEAR
    rcall LCD_CLEAR

    ; ZEILE1
    ldi ZH, high(TEXT_LEER*2)    ; TEXT
    ldi ZL,  low(TEXT_LEER*2)
    rcall ANZEIGE_TEXT

    ; ZEILE2
    rcall LCD_ZEILE2

    LDS temp1,(adr_MENUE)
    clr temp2
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_7_STELLEN_KURZ

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_FREQUENZ_AKTUELL:
    ; CLEAR
    rcall LCD_CLEAR

    ; ZEILE1
    ldi ZH, high(TEXT_FREQUENZ_AKTUELL*2)    ; TEXT
    ldi ZL,  low(TEXT_FREQUENZ_AKTUELL*2)
    rcall ANZEIGE_TEXT

    ; ZEILE2
    rcall LCD_ZEILE2

    LDS temp1,(adr_FREQUENZ_MOMENTAN_BYTE_1)
    LDS temp2,(adr_FREQUENZ_MOMENTAN_BYTE_2)
    LDS temp3,(adr_FREQUENZ_MOMENTAN_BYTE_3)
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_9_STELLEN_KURZ

    ; EINHEIT
    rcall LCD_SPACE
    ldi temp, 'H'        ;
    rcall LCD_DATA
    ldi temp, 'z'        ;
    rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_FREQUENZ_KALIBRIERUNG:
    ; CLEAR
    rcall LCD_CLEAR

    ; ZEILE1
    ldi ZH, high(TEXT_FREQUENZ_KALIBRIERUNG*2)    ; TEXT
    ldi ZL,  low(TEXT_FREQUENZ_KALIBRIERUNG*2)
    rcall ANZEIGE_TEXT

    ; ZEILE2
    rcall LCD_ZEILE2


    LDS temp1,(adr_FREQUENZ_F1_BYTE_1)
    LDS temp2,(adr_FREQUENZ_F1_BYTE_2)
    LDS temp3,(adr_FREQUENZ_F1_BYTE_3)
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_7_STELLEN_KURZ


    rcall LCD_SPACE

    LDS temp1,(adr_FREQUENZ_KALI_BYTE_1)
    LDS temp2,(adr_FREQUENZ_KALI_BYTE_2)
    LDS temp3,(adr_FREQUENZ_KALI_BYTE_3)
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_7_STELLEN_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_KALIBRIERUNG:
    ; CLEAR
    rcall LCD_CLEAR

    ; ZEILE1
    ldi ZH, high(TEXT_KALIBRIERUNG*2)    ; TEXT
    ldi ZL,  low(TEXT_KALIBRIERUNG*2)
    rcall ANZEIGE_TEXT

    ; ZEILE2
    rcall LCD_ZEILE2



ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_REFERENZ_C:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE1
    ldi ZH, high(TEXT_REFERENZ_C*2)    ; TEXT
    ldi ZL,  low(TEXT_REFERENZ_C*2)
    rcall ANZEIGE_TEXT

    ; ZEILE2
    rcall LCD_ZEILE2

    LDS temp1,(adr_REFERENZ_C_BYTE_1)
    LDS temp2,(adr_REFERENZ_C_BYTE_2)
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_6_STELLEN_KURZ

    rcall LCD_SPACE
    ldi temp, 'p'        ;
    rcall LCD_DATA
    ldi temp, 'F'        ;
    rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_EDIT_REFERENZ_C:
    ; TASTE
    LDS temp,(adr_TASTE)
    cpi temp,(TASTE_PLUS)
    breq ANZEIGE_EDIT_REFERENZ_C_PLUS
    cpi temp,(TASTE_MINUS)
    breq ANZEIGE_EDIT_REFERENZ_C_MINUS
    rjmp ANZEIGE_EDIT_REFERENZ_START

ANZEIGE_EDIT_REFERENZ_C_PLUS:
    ; KONDENSATOR+1pF
    LDS temp1,(adr_REFERENZ_C_BYTE_1)
    LDS temp2,(adr_REFERENZ_C_BYTE_2)
    add temp1,EINS
    adc temp2,NULL
    STS (adr_REFERENZ_C_BYTE_1),temp1
    STS (adr_REFERENZ_C_BYTE_2),temp2
    ; TASTE CLEAR
    STS (adr_TASTE),NULL
    ; speichern aktivieren
    STS (adr_KONFIGURATION_SPEICHERN),EINS
    rjmp ANZEIGE_EDIT_REFERENZ_START

ANZEIGE_EDIT_REFERENZ_C_MINUS:
    ; KONDENSATOR-1pF
    LDS temp1,(adr_REFERENZ_C_BYTE_1)
    LDS temp2,(adr_REFERENZ_C_BYTE_2)
    sub temp1,EINS
    sbc temp2,NULL
    STS (adr_REFERENZ_C_BYTE_1),temp1
    STS (adr_REFERENZ_C_BYTE_2),temp2
    ; TASTE CLEAR
    STS (adr_TASTE),NULL
    ; speichern aktivieren
    STS (adr_KONFIGURATION_SPEICHERN),EINS
    rjmp ANZEIGE_EDIT_REFERENZ_START

ANZEIGE_EDIT_REFERENZ_START:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE1
    ldi ZH, high(TEXT_EDIT_REFERENZ_C*2)    ; TEXT
    ldi ZL,  low(TEXT_EDIT_REFERENZ_C*2)
    rcall ANZEIGE_TEXT

    ; ZEILE2
    rcall LCD_ZEILE2

    LDS temp1,(adr_REFERENZ_C_BYTE_1)
    LDS temp2,(adr_REFERENZ_C_BYTE_2)
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_6_STELLEN_KURZ

    rcall LCD_SPACE
    rcall LCD_DATA
    ldi temp, 'p'        ;
    rcall LCD_DATA
    ldi temp, 'F'        ;
    rcall LCD_DATA

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_EDIT_SIMULATION_AKTIVIEREN:
    ; TASTE
    LDS temp,(adr_TASTE)
    cpi temp,(TASTE_PLUS)
    breq ANZEIGE_EDIT_SIMULATION_AKTIVIEREN_PLUS_MINUS
    cpi temp,(TASTE_MINUS)
    breq ANZEIGE_EDIT_SIMULATION_AKTIVIEREN_PLUS_MINUS
    rjmp ANZEIGE_EDIT_SIMULATION_AKTIVIEREN_START

ANZEIGE_EDIT_SIMULATION_AKTIVIEREN_PLUS_MINUS:
    LDS temp,(adr_SIMULATION_AKTIV)
    inc temp
    STS(adr_SIMULATION_AKTIV),temp
    ; Fehlerprfung
    cpi temp,2
    brlo ANZEIGE_EDIT_SIMULATION_AKTIVIEREN_START
    STS(adr_SIMULATION_AKTIV),NULL
ANZEIGE_EDIT_SIMULATION_AKTIVIEREN_START:
;-------------------------------------------------------------------------------
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE1
    ldi ZH, high(TEXT_SIMULATION*2)    ; TEXT
    ldi ZL,  low(TEXT_SIMULATION*2)
    rcall ANZEIGE_TEXT


    ; ZEILE2
    rcall LCD_ZEILE2

    LDS temp1,(adr_SIMULATION_AKTIV)
    clr temp2
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_L_C:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE 1
    ldi temp, 'L'        ;
    rcall LCD_DATA
    ldi temp, '='        ;
    rcall LCD_DATA

    LDS temp1,(adr_INDUKTIVITAET_BYTE_1)
    LDS temp2,(adr_INDUKTIVITAET_BYTE_2)
    LDS temp3,(adr_INDUKTIVITAET_BYTE_3)
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_7_STELLEN_KURZ

    rcall LCD_SPACE
    ldi temp, 228        ;
    rcall LCD_DATA
    ldi temp, 'H'        ;
    rcall LCD_DATA


    ; ZEILE 2
    rcall LCD_ZEILE2

    ldi temp, 'C'        ;
    rcall LCD_DATA
    ldi temp, '='        ;
    rcall LCD_DATA

    LDS temp1,(adr_KAPAZITAET_BYTE_1)
    LDS temp2,(adr_KAPAZITAET_BYTE_2)
    LDS temp3,(adr_KAPAZITAET_BYTE_3)
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_7_STELLEN_KURZ

    rcall LCD_SPACE
    ldi temp, 'p'        ;
    rcall LCD_DATA
    ldi temp, 'F'        ;
    rcall LCD_DATA


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TASTE:

    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE1
    ldi ZH, high(TEXT_TASTATUR*2)    ; TEXT
    ldi ZL,  low(TEXT_TASTATUR*2)
    rcall ANZEIGE_TEXT

    ; ZEILE2
    rcall LCD_ZEILE2

    LDS temp1,(adr_TASTE)
    clr temp2
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_WAIT:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE1
    ldi ZH, high(TEXT_WAIT*2)    ; TEXT
    ldi ZL,  low(TEXT_WAIT*2)
    rcall ANZEIGE_TEXT

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_HILFE_TASTE:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE1
    ldi ZH, high(TEXT_HILFE_1*2)    ; TEXT
    ldi ZL,  low(TEXT_HILFE_1*2)
    rcall ANZEIGE_TEXT
    ; ZEILE 2
    rcall LCD_ZEILE2
    ldi ZH, high(TEXT_HILFE_2*2)    ; TEXT
    ldi ZL,  low(TEXT_HILFE_2*2)
    rcall ANZEIGE_TEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_WERKSEINSTELLUNG_1nF:
    ldi temp1,low (1000)
    ldi temp2,high(1000)
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_1),temp1
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_2),temp2
    rcall ANZEIGE_WERKSEINSTELLUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_WERKSEINSTELLUNG_2nF:
    ldi temp1,low (2000)
    ldi temp2,high(2000)
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_1),temp1
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_2),temp2
    rcall ANZEIGE_WERKSEINSTELLUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_WERKSEINSTELLUNG_3nF:
    ldi temp1,low (3520)
    ldi temp2,high(3520)
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_1),temp1
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_2),temp2
    rcall ANZEIGE_WERKSEINSTELLUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_WERKSEINSTELLUNG_4nF:
    ldi temp1,low (4000)
    ldi temp2,high(4000)
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_1),temp1
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_2),temp2
    rcall ANZEIGE_WERKSEINSTELLUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_WERKSEINSTELLUNG_5nF:
    ldi temp1,low (5000)
    ldi temp2,high(5000)
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_1),temp1
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_2),temp2
    rcall ANZEIGE_WERKSEINSTELLUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_WERKSEINSTELLUNG_10nF:
    ldi temp1,low (10000)
    ldi temp2,high(10000)
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_1),temp1
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_2),temp2
    rcall ANZEIGE_WERKSEINSTELLUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_WERKSEINSTELLUNG_60nF:
    ldi temp1,low (60000)
    ldi temp2,high(60000)
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_1),temp1
    STS (adr_WERKSEINSTELLUNG_C_REF_BYTE_2),temp2
    rcall ANZEIGE_WERKSEINSTELLUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_WERKSEINSTELLUNG:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE1
    ldi ZH, high(TEXT_WERKSEINSTELLUNG*2)    ; TEXT
    ldi ZL,  low(TEXT_WERKSEINSTELLUNG*2)
    rcall ANZEIGE_TEXT
    ; ZEILE 2
    rcall LCD_ZEILE2
    ; Werkseinstellung
    LDS temp1,(adr_WERKSEINSTELLUNG_C_REF_BYTE_1)
    LDS temp2,(adr_WERKSEINSTELLUNG_C_REF_BYTE_2)
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_6_STELLEN_KURZ

    rcall LCD_SPACE
    ldi temp, 'p'        ;
    rcall LCD_DATA
    ldi temp, 'F'        ;
    rcall LCD_DATA
;------------------------------------------------------------------------------
    ; TASTE
    LDS temp,(adr_TASTE)
    ; Menue + gedrckt ?
    cpi temp,(TASTE_PLUS)
    breq ANZEIGE_WERKSEINSTELLUNG_w
    ret
ANZEIGE_WERKSEINSTELLUNG_w:
    ; Referenz Kondensator zuweisen
    LDS temp1,(adr_WERKSEINSTELLUNG_C_REF_BYTE_1)
    LDS temp2,(adr_WERKSEINSTELLUNG_C_REF_BYTE_2)
    STS(adr_REFERENZ_C_BYTE_1),temp1
    STS(adr_REFERENZ_C_BYTE_2),temp2

    ; ANZEIGE wait
    rcall ANZEIGE_WAIT
    rcall wait_100ms
    ; MENUE = EINS = EDIT Referenzkondensator
    STS(adr_MENUE),EINS
    ; speichern aktivieren
    STS (adr_KONFIGURATION_SPEICHERN),EINS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_RESET:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE1
    ldi ZH, high(TEXT_RESET*2)    ; TEXT
    ldi ZL,  low(TEXT_RESET*2)
    rcall ANZEIGE_TEXT
    ; TASTE
    LDS temp,(adr_TASTE)
    ; Menue + gedrckt ?
    cpi temp,(TASTE_PLUS)
    breq ANZEIGE_RESET_SCHLEIFE
    ret
ANZEIGE_RESET_SCHLEIFE:
    rcall ANZEIGE_WAIT
    ; RESET ber ENDLOSSCHLEIFE bis WDR zubeit
ANZEIGE_RESET_SCHLEIFE_w:
    rjmp ANZEIGE_RESET_SCHLEIFE_w
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_PROGRAMMSTARTS:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE1
    ldi ZH, high(TEXT_PROGRAMM_STARTS*2)    ; TEXT
    ldi ZL,  low(TEXT_PROGRAMM_STARTS*2)
    rcall ANZEIGE_TEXT


    rcall LCD_ZEILE2
    ; Z-ZEIGER initialisieren
    ldi ZL,low (adr_EEPROM_ANZAHL_STARTS_L)
    ldi ZH,high(adr_EEPROM_ANZAHL_STARTS_L)
    ; aus EEPROM lesen und Z+1
    rcall EEPROM_READ_PLUS ; INP: ZL+ZH(ADRESSE) OUT: TEMP (DATEN)
    mov temp1,temp
    ; aus EEPROM lesen und Z+1
    rcall EEPROM_READ_PLUS ; INP: ZL+ZH(ADRESSE) OUT: TEMP (DATEN)
    mov temp2,temp

    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_FORMAT
    rcall LCD_AUSGABE_ZAHL_6_STELLEN_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ERROR_KALIBRIERUNG_A:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE1
    ldi ZH, high(TEXT_ERROR*2)    ; TEXT
    ldi ZL,  low(TEXT_ERROR*2)
    rcall ANZEIGE_TEXT
    ; ZEILE 2
    rcall LCD_ZEILE2
    ldi ZH, high(TEXT_KEINE_FREQUENZ*2)    ; TEXT
    ldi ZL,  low(TEXT_KEINE_FREQUENZ*2)
    rcall ANZEIGE_TEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ERROR_KALIBRIERUNG_B:
    ; CLEAR
    rcall LCD_CLEAR
    ; ZEILE1
    ldi ZH, high(TEXT_ERROR*2)    ; TEXT
    ldi ZL,  low(TEXT_ERROR*2)
    rcall ANZEIGE_TEXT
    ; ZEILE 2
    rcall LCD_ZEILE2
    ldi ZH, high(TEXT_FREQUEMZFEHLER*2)    ; TEXT
    ldi ZL,  low(TEXT_FREQUEMZFEHLER*2)
    rcall ANZEIGE_TEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEST_A:
    rcall LCD_CLEAR

    LDS temp1,(adr_TEST_A_BYTE_8)
    clr temp2
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
    rcall LCD_PUNKT

    LDS temp1,(adr_TEST_A_BYTE_7)
    clr temp2
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
    rcall LCD_PUNKT

    LDS temp1,(adr_TEST_A_BYTE_6)
    clr temp2
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
    rcall LCD_PUNKT

    LDS temp1,(adr_TEST_A_BYTE_5)
    clr temp2
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ

    rcall LCD_ZEILE2

    LDS temp1,(adr_TEST_A_BYTE_4)
    clr temp2
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
    rcall LCD_PUNKT

    LDS temp1,(adr_TEST_A_BYTE_3)
    clr temp2
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
    rcall LCD_PUNKT

    LDS temp1,(adr_TEST_A_BYTE_2)
    clr temp2
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
    rcall LCD_PUNKT

    LDS temp1,(adr_TEST_A_BYTE_1)
    clr temp2
    clr temp3
    clr temp4
    rcall FUNKTION_HEX_ASC_32    ; INPUT: temp1...4 OUTPUT: Temp1...8
    rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
ret